﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
'Gui for the mixer which holds a scrollpane that in turn holds the channel Gui's.

Sub Class_Globals
	Private fx As JFX
	Private Xui As XUI 'ignore
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Public Tag As Object
	Private ScrollPane1 As ScrollPane
	Private InnerPane As Pane
	Private Channel_CV1 As Channel_CV
	Private TrackMap As Map
	Private Group As JavaObject
	Private LblClipIndex As Int = 0
	Private LblSoundIndex As Int = 11
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	TrackMap.Initialize
	Group.InitializeNewInstance("javafx.scene.control.ToggleGroup",Null)
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me 
  	mBase.LoadLayout("TrackMixer_CV")
	ScrollPane1.InnerNode = InnerPane
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
	InnerPane.As(B4XView).Height = Height
	If Channel_CV1.IsInitialized Then
		InnerPane.As(B4XView).Width = Max(Channel_CV1.mBase.Width, 105 * (InnerPane.NumberOfNodes + 1))
	Else
		InnerPane.As(B4XView).Width = Width
	End If
End Sub

'Add a Channel_CV for each track
Public Sub SetTracks
	InnerPane.RemoveAllNodes
	TrackMap.Clear
	Dim i As Int
	For Each SF As SourceFileType In TrackMixer_G.SourceFilesList
		Dim P As B4XView = Xui.CreatePanel("")
		P.SetLayoutAnimated(0,0,0,200,mBase.Height)
		P.LoadLayout("channel_cv")
		P.Tag = SF
		InnerPane.AddNode(P, i * 105,0,100,mBase.Height - 30)
		Channel_CV1.setTrack(SF.Track,SF.FileName)
		TrackMap.Put(SF.Track,P)
		i = i + 1
		Dim LblClip As JavaObject = P.GetView(0).GetView(0).GetView(LblClipIndex)
		LblClip.RunMethod("setMinHeight",Array(5.0))
		Dim LblSound As JavaObject = P.GetView(0).GetView(0).GetView(LblSoundIndex)
		LblSound.RunMethod("setMinHeight",Array(5.0))
		
	Next
	InnerPane.As(B4XView).Width = Max(Channel_CV1.mBase.Width, 105 * (InnerPane.NumberOfNodes + 1))
End Sub

Public Sub FlashClip(MT As MixerTrack)
	Dim LblClip As B4XView = TrackMap.Get(MT).As(B4XView).GetView(0).GetView(0).GetView(LblClipIndex)
	CSSUtils.SetBackgroundColor(LblClip,fx.Colors.Red)
	Sleep(100)
	CSSUtils.SetBackgroundColor(LblClip,fx.Colors.LightGray)
End Sub

Public Sub FlashSound(MT As MixerTrack)
	Dim LblSound As B4XView = TrackMap.Get(MT).As(B4XView).GetView(0).GetView(0).GetView(LblSoundIndex)
	CSSUtils.SetBackgroundColor(LblSound,fx.Colors.Green)
	Sleep(100)
	CSSUtils.SetBackgroundColor(LblSound,fx.Colors.LightGray)
End Sub

